function [m]=get_m(theta,data_cell,V_cell,sims_cell,overid,theta_true,restrict_rho,restrict_sigma,known_fs,max_years);

 
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%% SETUP %%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
        %%%Unpack data;
        l=1;
        alpha_hat=cell2mat(data_cell(l)); l=l+1;
        rho_hat=cell2mat(data_cell(l)); l=l+1;
        pi_hat=cell2mat(data_cell(l)); l=l+1;
        P=cell2mat(data_cell(l)); l=l+1; 
        A=cell2mat(data_cell(l)); l=l+1;
        Q=cell2mat(data_cell(l));
        
        %%%Unpack sims;
        l=1;
        sims_omega_j=cell2mat(sims_cell(l)); l=l+1;
        sims_omega_tilde=cell2mat(sims_cell(l)); l=l+1;
        sims_nu=cell2mat(sims_cell(l)); l=l+1;
        sims_e=cell2mat(sims_cell(l));
        
        %%%%Unpack measurement error parameters;
        l=1;
        V_alpha=cell2mat(V_cell(l)); l=l+1;
        V_rho=cell2mat(V_cell(l));
        
        %%%Unpack parameters of DGP;
        T=length(alpha_hat(1,:));
        J=length(alpha_hat(:,1));
        R=length(sims_omega_j(1,1,:));
                
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% COMPUTE MOMENTS ON REAL DATA %%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
        m_hat=moments(alpha_hat,rho_hat,pi_hat,V_alpha,V_rho,P,A,Q,overid,restrict_rho,restrict_sigma,known_fs);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% COMPUTE MOMENTS ON SIMULATED DATA %%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        M_sim=zeros(length(m_hat),R);
        
        for r=1:R;
            
            %%%Draw simulated data;
            sims_omega_j_r=reshape(sims_omega_j(:,:,r),[J 4]);
            sims_omega_tilde_r=reshape(sims_omega_tilde(:,:,:,r),[J 2 T]);
            sims_nu_r=reshape(sims_nu(:,:,:,r),[J J T]);
            sims_e_r=reshape(sims_e(:,:,r),[J*(2+J) T]);
            [alpha_sim rho_sim pi_sim]=sim_data(theta,P,A,Q,sims_omega_j_r,sims_omega_tilde_r,sims_nu_r,sims_e_r,pi_hat,theta_true,restrict_rho,restrict_sigma,known_fs,max_years);
            
            %%%Compute moments on simulated data;
            M_sim(:,r)=moments(alpha_sim,rho_sim,pi_sim,V_alpha,V_rho,P,A,Q,overid,restrict_rho,restrict_sigma,known_fs);
            

        end;
        
        m=mean(M_sim,2);

        
    
    