function [m]=moments(alpha,rho,pi,V_alpha,V_rho,P,A,Q,overid,restrict_rho,restrict_sigma,known_fs);

        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%% PRELIMINARIES %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   %%%Preliminaries;
    J=length(alpha(:,1));
    T=length(alpha(1,:));
    K=length(P(1,:));
    m=[];
    
  %%%Count lotteries and observations;
    
    %Total lottos by year;
    L_t=sum(Q,1)';
    A_t=sum(A,1)';
    
    
  %%%Get key parameter transformations;
  
       %%%Own first stage;
       pi_own=zeros(J,T);
       for t=1:T;
           pi_own(:,t)=diag(pi(:,:,t));
           pi_own(:,t)=pi_own(:,t)+(1-Q(:,t))*0.1;
       end;
       
       %%%Other schools' first stage;
       pi_other=zeros(J,J,T);
       for t=1:T;
           pi_other(:,:,t)=pi(:,:,t) - diag(diag(pi(:,:,t)));
       end;
       pi_other_mean=reshape(sum(pi_other,2),[J T])./(repmat(sum(Q,1),[J 1]) - Q);
       complier_share=zeros(J,J,T);
       for t=1:T;
           complier_share(:,:,t)=pi_other(:,:,t)./repmat(pi_own(:,t)',[J 1]);
       end;
       complier_share(isnan(complier_share))=0;
       complier_share_mean=reshape(sum(complier_share,2),[J T])./(repmat(sum(Q,1),[J 1]) - Q);
       
       %%%Pseudo RF;
       tau=zeros(J,T);
       for t=1:T;
           tau(:,t) = sum(reshape(pi(:,:,t),[J J]).*repmat(alpha(:,t),[1 J]),1)';
           tau(:,t)=tau(:,t)+(1-Q(:,t))*0.1;
       end;
    
    %%%IV;
    IV=rho./pi_own;
    
    %Regressor matrices;
    P_lotto=zeros(J,K,T);
    P_obs=zeros(J,K,T);
    for t=1:T;
        P_lotto(:,:,t)=P.*repmat(Q(:,t),[1 K]);
        P_obs(:,:,t)=P.*repmat(A(:,t),[1 K]);
    end;
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%% MOMENTS %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


      %%%%%%%%%%% MEAN OLS FOR LOTTO VS. NON M2;

          m_temp=0;
          for t=1:T;
              mu_lotto=(1/sum(Q(:,t)))*sum(Q(:,t).*alpha(:,t));
              m_temp=m_temp+(1/T)*mu_lotto;
          end;
          m=[m; m_temp];
          
          
      %%%%%%%%%%% MEAN RF M3;

            P_temp=reshape(P_lotto(:,:,1),[J K]);
            P_temp = P_temp(:,sum(P_temp)~=0);
            m_temp=zeros(size(P_temp,2),1);
            for t=1:T;
                P_temp=reshape(P_lotto(:,:,t),[J K]);
                P_temp = P_temp(:,sum(P_temp)~=0);
                m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*rho(:,t);
            end;
            m=[m; m_temp];

            
      %%%%%%%%% MEAN IV AND PSEDUO RF M4, M5;
      
            if overid==1;
                
                P_temp=reshape(P_lotto(:,:,1),[J K]);
                P_temp = P_temp(:,sum(P_temp)~=0);
                m_temp=zeros(size(P_temp,2),1);
                for t=1:T;
                    P_temp=reshape(P_lotto(:,:,t),[J K]);
                    P_temp = P_temp(:,sum(P_temp)~=0);
                    m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*IV(:,t);
                end;
                m=[m; m_temp];
                
                P_temp=reshape(P_lotto(:,:,1),[J K]);
                P_temp = P_temp(:,sum(P_temp)~=0);
                m_temp=zeros(size(P_temp,2),1);
                for t=1:T;
                    P_temp=reshape(P_lotto(:,:,t),[J K]);
                    P_temp = P_temp(:,sum(P_temp)~=0);
                    m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*tau(:,t);
                end;
                m=[m; m_temp]; 
                
            end;
            
      %%%%%%%%%%% MEAN OLS M1;

            m_temp=zeros(K,1);
            for t=1:T;
                P_temp=reshape(P_obs(:,:,t),[J K]);
                m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*alpha(:,t);
            end;
            m=[m; m_temp];
            
      %%%%%%%%%%% MEAN OWN FIRST STAGE M6;
            if known_fs~=1;
                P_temp=reshape(P_lotto(:,:,1),[J K]);
                P_temp = P_temp(:,sum(P_temp)~=0);
                m_temp=zeros(size(P_temp,2),1);
                for t=1:T;
                    P_temp=reshape(P_lotto(:,:,t),[J K]);
                    P_temp = P_temp(:,sum(P_temp)~=0);
                    m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*pi_own(:,t);
                end;
                m=[m; m_temp];
            end;
            
      %%%%%%%%%%% MEAN FALLBACK PROB M7, M8;
            if known_fs~=1;
                m_temp=zeros(K,1);
                for t=1:T;
                    P_temp=reshape(P_obs(:,:,t),[J K]);
                    m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*pi_other_mean(:,t);
                end;
                m=[m; m_temp];

                if overid==1;

                    for t=1:T;
                        P_temp=reshape(P_obs(:,:,t),[J K]);
                        m_temp=m_temp+(1/T)*inv(P_temp'*P_temp)*P_temp'*complier_share_mean(:,t);
                    end;

                    m=[m; m_temp];
                end;
            end;
       

    %%%%%%%%%%% RF Variance M;
           
           m_temp=0;
           for t=1:T;
               mu_rho=(1/L_t(t))*sum(rho(:,t));
               m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((rho(:,t) - mu_rho).^2) );
           end;
           m=[m; m_temp];
     

           if overid==1;
               
               %%%%%Mean VA coef M9;
               
               m_temp=0;
               for t=1:T;
                   VA_coef=rho(:,t)./tau(:,t);
                   VA_weight=Q(:,t).*(pi_own(:,t).^2);
                   VA_weight=VA_weight/sum(VA_weight);
                   m_temp=m_temp+(1/T)*sum(VA_weight.*VA_coef);
               end;
               m=[m; m_temp];
               
               %%%%Var pseudo rf;
               
               m_temp=0;
               for t=1:T;
                   mu_tau=(1/L_t(t))*sum(tau(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((tau(:,t) - mu_tau).^2) );
               end;
               m=[m; m_temp];
              
           end;

    
    %%%%%%%%%%% OLS Variance;
           
           m_temp=0;
           for t=1:T;
               mu_alpha=(1/A_t(t))*sum(alpha(:,t));
               m_temp=m_temp+(1/T)*(1/A_t(t))*sum( A(:,t).*((alpha(:,t) - mu_alpha).^2) );
           end;
           m=[m; m_temp];


    %%%%%%%%%%% OWN FS variance;
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   mu_pi_own=(1/L_t(t))*sum(pi_own(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((pi_own(:,t) - mu_pi_own).^2) );
               end;
               m=[m; m_temp];
           end;
     


    %%%%%%%%%%% ACROSS SCHOOL FS VARIANCE;
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   mu_pi_other_mean=(1/A_t(t))*sum(pi_other_mean(:,t));
                   m_temp=m_temp+(1/T)*(1/A_t(t))*sum( A(:,t).*((pi_other_mean(:,t) - mu_pi_other_mean).^2) );
               end;
               m=[m; m_temp];

               if overid==1;

                   m_temp=0;
                   for t=1:T;
                       mu_complier_share_mean=(1/A_t(t))*sum(complier_share_mean(:,t));
                       m_temp=m_temp+(1/T)*(1/A_t(t))*sum( A(:,t).*((complier_share_mean(:,t) - mu_complier_share_mean).^2) );
                   end;
                   m=[m; m_temp];

               end;
           end;


    %%%%%%%%%%% W/IN SCHOOL FS VARIANCE;
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   pi_other_dev = repmat(A(:,t),[1 J]).*repmat(Q(:,t)',[J 1]).*(pi_other(:,:,t) - repmat(pi_other_mean(:,t),[1 J]));
                   mu_pi_other_dev=sum(sum(pi_other_dev))/(sum(Q(:,t))*(sum(A(:,t))-1));
                   m_temp=m_temp+(1/T)*(1/(sum(Q(:,t))*(sum(A(:,t))-1)))*sum(sum( repmat(A(:,t),[1 J]).*repmat(Q(:,t)',[J 1]).*((pi_other_dev-mu_pi_other_dev).^2) ));
               end;
               m=[m; m_temp];

               if overid==1;

                   m_temp=0;
                   for t=1:T;
                       complier_share_dev = repmat(A(:,t),[1 J]).*repmat(Q(:,t)',[J 1]).*(complier_share(:,:,t) - repmat(complier_share_mean(:,t),[1 J]));
                       mu_complier_share=sum(sum(complier_share_dev))/(sum(Q(:,t))*(sum(A(:,t))-1));
                       m_temp=m_temp+(1/T)*(1/(sum(Q(:,t))*(sum(A(:,t))-1)))*sum(sum( repmat(A(:,t),[1 J]).*repmat(Q(:,t)',[J 1]).*((complier_share_dev-mu_complier_share).^2) ));
                   end;
                   %m=[m; m_temp];   


               end;
           end;

    

 
    %%%%%%%%%%% COV RF and PSEUDO RF;
    
           m_temp=0;
           for t=1:T;
               mu_rho=(1/L_t(t))*sum(rho(:,t));
               mu_tau=(1/L_t(t))*sum(tau(:,t));
               m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((rho(:,t) - mu_rho).*(tau(:,t) - mu_tau)) );
           end;
           m=[m; m_temp];
           
           if overid==1;
               
               m_temp=0;
               for t=1:T;
                   mu_rho=(1/L_t(t))*sum(Q(:,t).*rho(:,t));
                   mu_alpha=(1/L_t(t))*sum(Q(:,t).*alpha(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((rho(:,t) - mu_rho).*(alpha(:,t) - mu_alpha)) );
               end;
               m=[m; m_temp];
               
           end;
           
      %%%%%%% COV RF AND OWN FS;  
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   mu_rho=(1/L_t(t))*sum(rho(:,t));
                   mu_pi_own=(1/L_t(t))*sum(pi_own(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((rho(:,t) - mu_rho).*(pi_own(:,t) - mu_pi_own)) );
               end;
               m=[m; m_temp];
           end;
           
           
      %%%%% COV RF AND AVG OTHER SCHOOL FS;
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   mu_rho=(1/L_t(t))*sum(rho(:,t));
                   mu_pi_other_mean=(1/L_t(t))*sum(Q(:,t).*pi_other_mean(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((rho(:,t) - mu_rho).*(pi_other_mean(:,t) - mu_pi_other_mean)) );
               end;
               m=[m; m_temp];
           end;
           
      %%%%% COV OLS AND AVG OWN FS;
        
           m_temp=0;
           for t=1:T;
               mu_alpha=(1/L_t(t))*sum(Q(:,t).*alpha(:,t));
               mu_pi_own=(1/L_t(t))*sum(pi_own(:,t));
               m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((alpha(:,t) - mu_alpha).*(pi_own(:,t) - mu_pi_own)) );
           end;
           m=[m; m_temp];
           
           
      %%%%% COV OLS AND AVG OTHER SCHOOL FS;
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   mu_alpha=(1/L_t(t))*sum(Q(:,t).*alpha(:,t));
                   mu_pi_other_mean=(1/L_t(t))*sum(Q(:,t).*pi_other_mean(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((alpha(:,t) - mu_alpha).*(pi_other_mean(:,t) - mu_pi_other_mean)) );
               end;
               m=[m; m_temp];
           end;
           
      %%%%% COV OWN FS AND AVG OTHER SCHOOL FS;
           if known_fs~=1;
               m_temp=0;
               for t=1:T;
                   mu_pi_own=(1/L_t(t))*sum(Q(:,t).*pi_own(:,t));
                   mu_pi_other_mean=(1/L_t(t))*sum(Q(:,t).*pi_other_mean(:,t));
                   m_temp=m_temp+(1/T)*(1/L_t(t))*sum( Q(:,t).*((pi_own(:,t) - mu_pi_own).*(pi_other_mean(:,t) - mu_pi_other_mean)) );
               end;
               m=[m; m_temp];
           end;

        if restrict_sigma~=1; 
            
            %%%%%%%% VARIANCE OF CHANGES IN RF;
            
            m_temp=0;
            for t=2:T;
                Q_t=Q(:,t);
                Q_minus=Q(:,t-1);
                n=sum(Q_t.*Q_minus);
                rho_t=rho(:,t);
                rho_minus=rho(:,t-1);
                delta_rho=(rho_t - rho_minus).*Q_t.*Q_minus;
                mu=(1/n)*sum(delta_rho);
                m_temp=m_temp+(1/(T-1))*(1/n)*sum( Q_t.*Q_minus.*((delta_rho - mu).^2) );
            end;
            m=[m; m_temp];
            


            %%%%%%%% VARIANCE OF CHANGES IN OLS;
    
            m_temp=0;
            for t=2:T;
                A_t=A(:,t);
                A_minus=A(:,t-1);
                n=sum(A_t.*A_minus);
                alpha_t=alpha(:,t);
                alpha_minus=alpha(:,t-1);
                delta_alpha=(alpha_t - alpha_minus).*A_t.*A_minus;
                mu=(1/n)*sum(delta_alpha);
                m_temp=m_temp+(1/(T-1))*(1/n)*sum( A_t.*A_minus.*((delta_alpha - mu).^2) );
            end;
            m=[m; m_temp];
            
            if restrict_rho~=1;
                
               %%%%%%%% COVARIANCE OF CHANGES IN RF AND PSEUDO RF;
               
                m_temp=0;
                for t=2:T;
                    Q_t=Q(:,t);
                    Q_minus=Q(:,t-1);
                    n=sum(Q_t.*Q_minus);
                    rho_t=rho(:,t);
                    rho_minus=rho(:,t-1);
                    tau_t=tau(:,t);
                    tau_minus=tau(:,t-1);
                    delta_rho=(rho_t - rho_minus).*Q_t.*Q_minus;
                    delta_tau=(tau_t - tau_minus).*Q_t.*Q_minus;
                    mu_rho=(1/n)*sum(delta_rho);
                    mu_tau=(1/n)*sum(delta_tau);
                    m_temp=m_temp+(1/(T-1))*(1/n)*sum( Q_t.*Q_minus.*(delta_rho - mu_rho).*(delta_tau - mu_tau) );
                end;
                m=[m; m_temp];
                
            end;
            
            if overid==1;
                
                %%%%%%%% VARIANCE OF CHANGES IN PSEDUO RF;
                
                    m_temp=0;
                    for t=2:T;
                        Q_t=Q(:,t);
                        Q_minus=Q(:,t-1);
                        n=sum(Q_t.*Q_minus);
                        tau_t=tau(:,t);
                        tau_minus=tau(:,t-1);
                        delta_tau=(tau_t - tau_minus).*Q_t.*Q_minus;
                        mu=(1/n)*sum(delta_tau);
                        m_temp=m_temp+(1/(T-1))*(1/n)*sum( Q_t.*Q_minus.*((delta_tau - mu).^2) );
                    end;
                    m=[m; m_temp];
                
            end;

        end;
          