function [alpha_hat rho_hat pi_hat]=sim_data(theta,P,A,Q,sims_omega_j,sims_omega_tilde,sims_nu,sims_e,pi_true,theta_true,restrict_rho,restrict_sigma,known_fs,max_years);
            

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% SETUP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
       %%%Data dimensions;
            J=length(P(:,1));
            K=length(P(1,:));
            T=length(sims_omega_tilde(1,1,:));
            
            
       %%%Unpack parameter vector;
            theta_new=theta;
            theta=theta_true;
            sigma_beta_tilde=0;
            sigma_b_tilde=0;
            rho_tilde=0;
            chol_Sigma=zeros(4,4);
            theta_P=zeros(4,K);
            l=1;
            beta_Q=theta(l); l=l+1;
            if known_fs~=1;
                theta_P=reshape(theta(l:(l+(4*K)-1)),[4 K]); l=l+(4*K);
            end;
            if known_fs==1;
                theta_P(1:2,:)=reshape(theta(l:(l+(2*K)-1)),[2 K]); l=l+(2*K);
            end;
            for t=1:2;
                chol_Sigma(t,t)=exp(theta(l)); l=l+1;
            end;
            if known_fs~=1;
                for t=3:4;
                    chol_Sigma(t,t)=exp(theta(l)); l=l+1;
                end;
            end;
            chol_Sigma(1,2)=theta(l); l=l+1;
            if known_fs~=1;
                chol_Sigma(1,3:end)=theta(l:(l+1)); l=l+2;
                chol_Sigma(2,3:end)=theta(l:(l+1)); l=l+2;
                chol_Sigma(3,4)=theta(l); l=l+1;
                sigma_nu=exp(theta(l)); l=l+1;
            end;
            if restrict_sigma~=1;
                sigma_beta_tilde=exp(theta(l)); l=l+1;
                sigma_b_tilde=exp(theta(l)); l=l+1;
            end;
            if restrict_rho~=1;
                rho_tilde=(exp(2*theta(l))-1)/(exp(2*theta(l))+1); l=l+1;
            end;
            

       %%%Unpack parameter vector;
            theta=theta_new;
            l=1;
            beta_Q=theta(l); l=l+1;
            if known_fs~=1;
                theta_P=reshape(theta(l:(l+(4*K)-1)),[4 K]); l=l+(4*K);
            end;
            if known_fs==1;
                theta_P(1:2,:)=reshape(theta(l:(l+(2*K)-1)),[2 K]); l=l+(2*K);
            end;
            for t=1:2;
                chol_Sigma(t,t)=exp(theta(l)); l=l+1;
            end;
            if known_fs~=1;
                for t=3:4;
                    chol_Sigma(t,t)=exp(theta(l)); l=l+1;
                end;
            end;
            chol_Sigma(1,2)=theta(l); l=l+1;
            if known_fs~=1;
                chol_Sigma(1,3:end)=theta(l:(l+1)); l=l+2;
                chol_Sigma(2,3:end)=theta(l:(l+1)); l=l+2;
                chol_Sigma(3,4)=theta(l); l=l+1;
                sigma_nu=exp(theta(l)); l=l+1;
            end;
            if restrict_sigma~=1;
                sigma_beta_tilde=exp(theta(l)); l=l+1;
                sigma_b_tilde=exp(theta(l)); l=l+1;
            end;
            if restrict_rho~=1;
                rho_tilde=(exp(2*theta(l))-1)/(exp(2*theta(l))+1); l=l+1;
            end;
            
            
            
       %%%%Format parameters;
            cov_tilde=rho_tilde*sigma_beta_tilde*sigma_b_tilde;
            
       %%%Simulate data;    
       
            %Random coefs;
            omega_j=P*(theta_P')+sims_omega_j*chol_Sigma;
            omega_j(:,1)=omega_j(:,1)+beta_Q*(1-prod(1-Q,2));
            omega_tilde=zeros(J,4,T);
            omega=zeros(J,4,T);
            beta=zeros(J,T);
            b=zeros(J,T);
            delta=zeros(J,T);
            chi=zeros(J,T);
            for t=1:T;
                if restrict_sigma~=1;
                    omega_tilde(:,1,t)=sigma_beta_tilde*sims_omega_tilde(:,1,t);
                    omega_tilde(:,2,t)=((cov_tilde/sigma_beta_tilde)*sims_omega_tilde(:,1,t)) ...
                                    +sqrt((sigma_b_tilde^2)-((cov_tilde/sigma_beta_tilde)^2))*sims_omega_tilde(:,2,t);
                end;
                omega(:,:,t)=omega_j+omega_tilde(:,:,t);
                beta(:,t)=omega(:,1,t);
                b(:,t)=omega(:,2,t);
                delta(:,t)=omega(:,3,t);
                chi(:,t)=omega(:,4,t);
            end;
            
            %First stage;
            if known_fs~=1;
                chi_tilde=repmat(reshape(chi,[J 1 T]),[1 J 1])+sigma_nu*sims_nu;
                pi_jj=exp(delta)./(1+exp(delta));
            end;
            pi=pi_true;
            rho=zeros(J,T);
            for t=1:T;
                if known_fs~=1;
                    A_temp=A(:,t);
                    for j=1:J;
                        u_temp=exp(chi_tilde(:,j,t)).*A_temp;
                        u_temp(j)=0;
                        fallback=u_temp./(1+sum(u_temp));
                        pi(:,j,t)=-pi_jj(j,t).*fallback;
                        pi(j,j,t)=pi_jj(j,t);
                        pi(:,j,t)=pi(:,j,t)*Q(j,t);
                        pi(:,j,t)=pi(:,j,t)*max_years;
                    end;
                end;
                rho(:,t)=Q(:,t).*(sum(pi(:,:,t).*repmat(beta(:,t),[1 J]),1)');
            end;

            %Reformat random coefs;
            alpha=beta+b;
            rho=zeros(J,T);
            for t=1:T;
                rho(:,t)=Q(:,t).*(sum(pi(:,:,t).*repmat(beta(:,t),[1 J]),1)');
            end;

            %Observed data;
            e=sims_e;
            e_pi=zeros(J,J,T);
            e_pi_long=e(((2*J)+1):end,:);
            if known_fs~=1;
                for t=1:T;
                    e_temp=e_pi_long(:,t);
                    e_pi(:,:,t)=reshape(e_temp,[J J]);
                end;
            end;
            alpha_hat=A.*(alpha+e(1:J,:));
            rho_hat=Q.*(rho+e((J+1):(2*J),:));
            pi_hat=pi+e_pi;
            for t=1:T;
                pi_hat(:,:,t)=pi_hat(:,:,t).*repmat(A(:,t),[1 J]).*repmat(Q(:,t)',[J 1]);
            end;

             
         
        