/* renumber schools so that those with QE data are first */
local vers "05122016"
set matsize 3000

clear
set more off
set varabbrev off
cd "C:\Users\Hull\Dropbox (MIT)\VAM\data"
insheet using reorder_05122016.csv, clear
forval i = 1/43 {
	qui summ newsch if oldsch==`i'
	local newsch_`i' = r(mean)
}

/* sectors */
insheet using ests`vers'\VAM_sects.csv, clear
gen temp = sch
forval i = 1/43 {
	replace sch = `newsch_`i'' if temp==`i'
}
drop temp
sort sch
order charter pilot sch
cap mkdir ests_reformat`vers'
export delimited using ests_reformat`vers'\VAM_sects.csv, novarnames replace

foreach model in 3 2d {
	forval test = 2/2 {

		/* ests */
		insheet using ests`vers'\VAM_ests_m`model'_test`test'_samp0.csv, clear

		forval i = 1/43 {
			rename vam_`i' n_vam_`newsch_`i''
			cap rename rf_`i' n_rf_`newsch_`i''
			if _rc == 0 {
				forval j = 1/43 {
					rename fs_`i'_`j' n_fs_`newsch_`i''_`newsch_`j''
				}
			}
		}
		
		foreach var of varlist n_* {
			local stub = substr("`var'",3,.)
			rename `var' `stub'
		}

		forval i = 23/43 {
			gen rf_`i' = -999
			forval j = 1/43 {
				gen fs_`i'_`j' = -999
			}
		}
		
		order *, sequential
		order vam_* rf_* fs_*_*
		format * %20.0g
		export delimited using ests_reformat`vers'\VAM_ests_m`model'_test`test'.csv, novarnames replace
		
		xpose, clear
		gen Q = (v1 != -999)
		keep Q
		xpose, clear
		export delimited using ests_reformat`vers'\Q.csv, novarnames replace

		/* vce */
		insheet using ests`vers'\VAM_vce_m`model'_test`test'_samp0.csv, clear
		
		gen row = ""
		local i = 1
		foreach var of varlist * {
			replace row = "`var'" if _n==`i'
			local ++i
		}
		forval i = 1/43 {
			rename vam_`i' n_vam_`newsch_`i''
			replace row = "n_vam_`newsch_`i''" if row == "vam_`i'"
			cap rename rf_`i' n_rf_`newsch_`i''
			cap replace row = "n_rf_`newsch_`i''" if row == "rf_`i'"
			forval j = 1/43 {
				cap rename fs_`i'_`j' n_fs_`newsch_`i''_`newsch_`j''
				cap replace row = "n_fs_`newsch_`i''_`newsch_`j''" if row == "fs_`i'_`j'"
			}
		}
		replace row = substr(row,3,.)
		foreach var of varlist n_* {
			local stub = substr("`var'",3,.)
			rename `var' `stub'
		}
		
		forval i = 23/43 {
			gen rf_`i' = -999
			local nobs = _N + 1
			qui set obs `nobs'
			replace row = "rf_`i'" if row == ""
			forval j = 1/43 {
				gen fs_`i'_`j' = -999
				local nobs = _N + 1
				qui set obs `nobs'
				replace row = "fs_`i'_`j'" if row == ""
			}
		}
		
		order *, sequential
		order vam_* rf_* fs_*_*
		gen seq = .
		local i = 1
		foreach var of varlist vam_* rf_* fs_*_* {
			replace seq = `i' if row == "`var'"
			local ++i
		}	
		sort seq
		drop row seq
		local i = 1
		foreach var of varlist * {
			qui summ `var'
			replace `var' = 0 if `var' == . | `var' == -999
			if r(min) == -999 {
				replace `var' = `i'/10000 in `i'
			}
			local ++i
		}	
		
		mkmat *, mat(V)
		matrix test = cholesky(V)
		format * %20.0g
		export delimited using ests_reformat`vers'\VAM_vce_m`model'_test`test'.csv, novarnames replace
		
	}
}


